Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.designer.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.designer.cs	(revision 4595)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.designer.cs	(revision 4598)
@@ -43,7 +43,7 @@
     partial void UpdateSlaveGroup_Resource(SlaveGroup_Resource instance);
     partial void DeleteSlaveGroup_Resource(SlaveGroup_Resource instance);
-    partial void InsertPluginInfo(PluginInfo instance);
-    partial void UpdatePluginInfo(PluginInfo instance);
-    partial void DeletePluginInfo(PluginInfo instance);
+    partial void InsertPlugin(Plugin instance);
+    partial void UpdatePlugin(Plugin instance);
+    partial void DeletePlugin(Plugin instance);
     partial void InsertProject(Project instance);
     partial void UpdateProject(Project instance);
@@ -64,4 +64,7 @@
     partial void UpdateHiveExperiment(HiveExperiment instance);
     partial void DeleteHiveExperiment(HiveExperiment instance);
+    partial void InsertJobData(JobData instance);
+    partial void UpdateJobData(JobData instance);
+    partial void DeleteJobData(JobData instance);
     #endregion
 		
@@ -122,9 +125,9 @@
 		}
 		
-		public System.Data.Linq.Table<PluginInfo> PluginInfos
-		{
-			get
-			{
-				return this.GetTable<PluginInfo>();
+		public System.Data.Linq.Table<Plugin> Plugins
+		{
+			get
+			{
+				return this.GetTable<Plugin>();
 			}
 		}
@@ -175,4 +178,20 @@
 			{
 				return this.GetTable<HiveExperiment>();
+			}
+		}
+		
+		public System.Data.Linq.Table<JobData> JobDatas
+		{
+			get
+			{
+				return this.GetTable<JobData>();
+			}
+		}
+		
+		public System.Data.Linq.Table<PluginData> PluginDatas
+		{
+			get
+			{
+				return this.GetTable<PluginData>();
 			}
 		}
@@ -876,6 +895,6 @@
 	}
 	
-	[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.PluginInfo")]
-	public partial class PluginInfo : INotifyPropertyChanging, INotifyPropertyChanged
+	[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.Plugin")]
+	public partial class Plugin : INotifyPropertyChanging, INotifyPropertyChanged
 	{
 		
@@ -906,5 +925,5 @@
     #endregion
 		
-		public PluginInfo()
+		public Plugin()
 		{
 			this._RequiredPlugins = new EntitySet<RequiredPlugin>(new Action<RequiredPlugin>(this.attach_RequiredPlugins), new Action<RequiredPlugin>(this.detach_RequiredPlugins));
@@ -1028,5 +1047,5 @@
 		{
 			this.SendPropertyChanging();
-			entity.PluginInfo = this;
+			entity.Plugin = this;
 		}
 		
@@ -1034,5 +1053,5 @@
 		{
 			this.SendPropertyChanging();
-			entity.PluginInfo = null;
+			entity.Plugin = null;
 		}
 	}
@@ -1164,5 +1183,5 @@
 		private System.Guid _PluginId;
 		
-		private EntityRef<PluginInfo> _PluginInfo;
+		private EntityRef<Plugin> _PluginInfo;
 		
 		private EntityRef<Job> _Job;
@@ -1182,5 +1201,5 @@
 		public RequiredPlugin()
 		{
-			this._PluginInfo = default(EntityRef<PluginInfo>);
+			this._PluginInfo = default(EntityRef<Plugin>);
 			this._Job = default(EntityRef<Job>);
 			OnCreated();
@@ -1256,5 +1275,5 @@
 		
 		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="PluginInfo_RequiredPlugin", Storage="_PluginInfo", ThisKey="PluginId", OtherKey="PluginId", IsForeignKey=true, DeleteRule="CASCADE")]
-		public PluginInfo PluginInfo
+		public Plugin Plugin
 		{
 			get
@@ -1264,5 +1283,5 @@
 			set
 			{
-				PluginInfo previousValue = this._PluginInfo.Entity;
+				Plugin previousValue = this._PluginInfo.Entity;
 				if (((previousValue != value) 
 							|| (this._PluginInfo.HasLoadedOrAssignedValue == false)))
@@ -1284,5 +1303,5 @@
 						this._PluginId = default(System.Guid);
 					}
-					this.SendPropertyChanged("PluginInfo");
+					this.SendPropertyChanged("Plugin");
 				}
 			}
@@ -1978,6 +1997,4 @@
 		private string _Exception;
 		
-		private System.Data.Linq.Link<System.Data.Linq.Binary> _SerializedJob;
-		
 		private System.Nullable<System.DateTime> _DateCreated;
 		
@@ -2001,4 +2018,6 @@
 		
 		private EntitySet<Job> _Jobs;
+		
+		private EntityRef<JobData> _JobData;
 		
 		private EntityRef<Job> _Job1;
@@ -2024,6 +2043,4 @@
     partial void OnExceptionChanging(string value);
     partial void OnExceptionChanged();
-    partial void OnSerializedJobChanging(System.Data.Linq.Binary value);
-    partial void OnSerializedJobChanged();
     partial void OnDateCreatedChanging(System.Nullable<System.DateTime> value);
     partial void OnDateCreatedChanged();
@@ -2049,4 +2066,5 @@
 			this._RequiredPlugins = new EntitySet<RequiredPlugin>(new Action<RequiredPlugin>(this.attach_RequiredPlugins), new Action<RequiredPlugin>(this.detach_RequiredPlugins));
 			this._Jobs = new EntitySet<Job>(new Action<Job>(this.attach_Jobs), new Action<Job>(this.detach_Jobs));
+			this._JobData = default(EntityRef<JobData>);
 			this._Job1 = default(EntityRef<Job>);
 			this._Project = default(EntityRef<Project>);
@@ -2183,24 +2201,4 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_SerializedJob", DbType="VarBinary(MAX)", CanBeNull=false, UpdateCheck=UpdateCheck.Never)]
-		public System.Data.Linq.Binary SerializedJob
-		{
-			get
-			{
-				return this._SerializedJob.Value;
-			}
-			set
-			{
-				if ((this._SerializedJob.Value != value))
-				{
-					this.OnSerializedJobChanging(value);
-					this.SendPropertyChanging();
-					this._SerializedJob.Value = value;
-					this.SendPropertyChanged("SerializedJob");
-					this.OnSerializedJobChanged();
-				}
-			}
-		}
-		
 		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_DateCreated", DbType="DateTime")]
 		public System.Nullable<System.DateTime> DateCreated
@@ -2403,4 +2401,33 @@
 			{
 				this._Jobs.Assign(value);
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Job_JobData", Storage="_JobData", ThisKey="JobId", OtherKey="JobId", IsUnique=true, IsForeignKey=false)]
+		public JobData JobData
+		{
+			get
+			{
+				return this._JobData.Entity;
+			}
+			set
+			{
+				JobData previousValue = this._JobData.Entity;
+				if (((previousValue != value) 
+							|| (this._JobData.HasLoadedOrAssignedValue == false)))
+				{
+					this.SendPropertyChanging();
+					if ((previousValue != null))
+					{
+						this._JobData.Entity = null;
+						previousValue.Job = null;
+					}
+					this._JobData.Entity = value;
+					if ((value != null))
+					{
+						value.Job = this;
+					}
+					this.SendPropertyChanged("JobData");
+				}
 			}
 		}
@@ -3018,4 +3045,176 @@
 		}
 	}
+	
+	[global::System.Data.Linq.Mapping.TableAttribute(Name="")]
+	public partial class JobData : INotifyPropertyChanging, INotifyPropertyChanged
+	{
+		
+		private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
+		
+		private System.Guid _JobId;
+		
+		private System.Data.Linq.Binary _Data;
+		
+		private EntityRef<Job> _Job;
+		
+    #region Extensibility Method Definitions
+    partial void OnLoaded();
+    partial void OnValidate(System.Data.Linq.ChangeAction action);
+    partial void OnCreated();
+    partial void OnJobIdChanging(System.Guid value);
+    partial void OnJobIdChanged();
+    partial void OnDataChanging(System.Data.Linq.Binary value);
+    partial void OnDataChanged();
+    #endregion
+		
+		public JobData()
+		{
+			this._Job = default(EntityRef<Job>);
+			OnCreated();
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_JobId", DbType="UniqueIdentifier NOT NULL", IsPrimaryKey=true)]
+		public System.Guid JobId
+		{
+			get
+			{
+				return this._JobId;
+			}
+			set
+			{
+				if ((this._JobId != value))
+				{
+					if (this._Job.HasLoadedOrAssignedValue)
+					{
+						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
+					}
+					this.OnJobIdChanging(value);
+					this.SendPropertyChanging();
+					this._JobId = value;
+					this.SendPropertyChanged("JobId");
+					this.OnJobIdChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Data", DbType="VarBinary(MAX)", CanBeNull=false, UpdateCheck=UpdateCheck.Never)]
+		public System.Data.Linq.Binary Data
+		{
+			get
+			{
+				return this._Data;
+			}
+			set
+			{
+				if ((this._Data != value))
+				{
+					this.OnDataChanging(value);
+					this.SendPropertyChanging();
+					this._Data = value;
+					this.SendPropertyChanged("Data");
+					this.OnDataChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Job_JobData", Storage="_Job", ThisKey="JobId", OtherKey="JobId", IsForeignKey=true)]
+		public Job Job
+		{
+			get
+			{
+				return this._Job.Entity;
+			}
+			set
+			{
+				Job previousValue = this._Job.Entity;
+				if (((previousValue != value) 
+							|| (this._Job.HasLoadedOrAssignedValue == false)))
+				{
+					this.SendPropertyChanging();
+					if ((previousValue != null))
+					{
+						this._Job.Entity = null;
+						previousValue.JobData = null;
+					}
+					this._Job.Entity = value;
+					if ((value != null))
+					{
+						value.JobData = this;
+						this._JobId = value.JobId;
+					}
+					else
+					{
+						this._JobId = default(System.Guid);
+					}
+					this.SendPropertyChanged("Job");
+				}
+			}
+		}
+		
+		public event PropertyChangingEventHandler PropertyChanging;
+		
+		public event PropertyChangedEventHandler PropertyChanged;
+		
+		protected virtual void SendPropertyChanging()
+		{
+			if ((this.PropertyChanging != null))
+			{
+				this.PropertyChanging(this, emptyChangingEventArgs);
+			}
+		}
+		
+		protected virtual void SendPropertyChanged(String propertyName)
+		{
+			if ((this.PropertyChanged != null))
+			{
+				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
+			}
+		}
+	}
+	
+	[global::System.Data.Linq.Mapping.TableAttribute(Name="")]
+	public partial class PluginData
+	{
+		
+		private System.Guid _PluginId;
+		
+		private System.Data.Linq.Binary _Data;
+		
+		public PluginData()
+		{
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_PluginId", DbType="UniqueIdentifier NOT NULL")]
+		public System.Guid PluginId
+		{
+			get
+			{
+				return this._PluginId;
+			}
+			set
+			{
+				if ((this._PluginId != value))
+				{
+					this._PluginId = value;
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Data", DbType="VarBinary(MAX) NOT NULL", CanBeNull=false, UpdateCheck=UpdateCheck.Never)]
+		public System.Data.Linq.Binary Data
+		{
+			get
+			{
+				return this._Data;
+			}
+			set
+			{
+				if ((this._Data != value))
+				{
+					this._Data = value;
+				}
+			}
+		}
+	}
 }
 #pragma warning restore 1591
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/Interfaces/IContextFactory.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/Interfaces/IContextFactory.cs	(revision 4595)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/Interfaces/IContextFactory.cs	(revision 4598)
@@ -24,5 +24,5 @@
 
 namespace HeuristicLab.Services.Hive.DataAccess {
-  public interface IContextFactory {
+  public interface IContextFactory<T> where T : DataContext {
     /// <summary>
     /// Uses transaction by default.
@@ -34,5 +34,5 @@
     IDisposable GetContext(bool withTransaction);
 
-    DataContext CurrentContext { get; }
+    T CurrentContext { get; }
 
     void RollbackTransaction();
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/Interfaces/IHiveDao.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/Interfaces/IHiveDao.cs	(revision 4598)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/Interfaces/IHiveDao.cs	(revision 4598)
@@ -0,0 +1,72 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Linq.Expressions;
+
+namespace HeuristicLab.Services.Hive.DataAccess {
+  using DT = HeuristicLab.Services.Hive.Common.DataTransfer;
+
+  public interface IHiveDao {
+    #region Job Methods
+    DT.Job GetJob(Guid id);
+    IEnumerable<DT.Job> GetJobs(Expression<Func<Job, bool>> predicate);
+    Guid AddJob(DT.Job dto);
+    void UpdateJob(DT.Job dto);
+    void DeleteJob(Guid id);
+    #endregion
+
+    #region JobData Methods
+    DT.JobData GetJobData(Guid id);
+    IEnumerable<DT.JobData> GetJobDatas(Expression<Func<JobData, bool>> predicate);
+    Guid AddJobData(DT.JobData dto);
+    void UpdateJobData(DT.JobData dto);
+    void DeleteJobData(Guid id);
+    #endregion
+
+    #region HiveExperiment Methods
+    DT.HiveExperiment GetHiveExperiment(Guid id);
+    IEnumerable<DT.HiveExperiment> GetHiveExperiments(Expression<Func<HiveExperiment, bool>> predicate);
+    Guid AddHiveExperiment(DT.HiveExperiment dto);
+    void UpdateHiveExperiment(DT.HiveExperiment dto);
+    void DeleteHiveExperiment(Guid id);
+    #endregion
+
+    #region Plugin Methods
+    #endregion
+
+    #region PluginData Methods
+    #endregion
+
+    #region Calendar Methods
+    #endregion
+
+    #region Slave Methods
+    DT.Slave GetSlave(Guid id);
+    IEnumerable<DT.Slave> GetSlaves(Expression<Func<Slave, bool>> predicate);
+    Guid AddSlave(DT.Slave dto);
+    void UpdateSlave(DT.Slave dto);
+    void DeleteSlave(Guid id);
+    #endregion
+
+    #region SlaveGroup Methods
+    DT.SlaveGroup GetSlaveGroup(Guid id);
+    IEnumerable<DT.SlaveGroup> GetSlaveGroups(Expression<Func<SlaveGroup, bool>> predicate);
+    Guid AddSlaveGroup(DT.SlaveGroup dto);
+    void UpdateSlaveGroup(DT.SlaveGroup dto);
+    void DeleteSlaveGroup(Guid id);
+    #endregion
+
+    #region Resource Methods
+    DT.Resource GetResource(Guid id);
+    IEnumerable<DT.Resource> GetResources(Expression<Func<Resource, bool>> predicate);
+    Guid AddResource(DT.Resource dto);
+    void UpdateResource(DT.Resource dto);
+    void DeleteResource(Guid id);
+    #endregion
+
+    #region Authorization Methods
+    bool IsUserAuthorizedForJobs(Guid userId, params Guid[] jobIds);
+    #endregion
+  }
+}
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Server/3.3/AuthorizationManager.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Server/3.3/AuthorizationManager.cs	(revision 4598)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Server/3.3/AuthorizationManager.cs	(revision 4598)
@@ -0,0 +1,53 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using System.Security;
+using System.Web.Security;
+
+namespace HeuristicLab.Services.Hive {
+  public class AuthorizationManager : IAuthorizationManager {
+    private MembershipUser Identity {
+      get { return Membership.GetUser(); }
+    }
+
+    public Guid UserId {
+      get { return (Guid)Identity.ProviderUserKey; }
+    }
+
+    public void AuthorizeJobs(params Guid[] jobIds) {
+      if (!IsAuthorizedForJobs(jobIds)) {
+        throw new SecurityException("User '" + Identity.UserName + "' is not authorized to access job (Id: " + string.Join(", ", jobIds.Select(x => x.ToString()).ToArray()) + ")");
+      }
+    }
+    
+    private bool IsAuthorizedForJobs(params Guid[] jobIds) {
+      return ServiceLocator.Instance.HiveDao.IsUserAuthorizedForJobs(UserId, jobIds);
+    }
+
+    public void Authorize(Guid userId) {
+      if (userId != this.UserId) {
+        throw new SecurityException("User '" + Identity.UserName + "' is not authorized to access object");
+      }
+    }
+  }
+}
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Server/3.3/HeuristicLab.Services.Hive-3.3.csproj
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Server/3.3/HeuristicLab.Services.Hive-3.3.csproj	(revision 4595)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Server/3.3/HeuristicLab.Services.Hive-3.3.csproj	(revision 4598)
@@ -44,7 +44,11 @@
       <HintPath>..\..\..\..\..\..\..\..\..\..\..\Program Files\HeuristicLab 3.3\HeuristicLab.PluginInfrastructure-3.3.dll</HintPath>
     </Reference>
+    <Reference Include="HeuristicLab.Tracing-3.3, Version=3.2.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="System" />
     <Reference Include="System.Core" />
+    <Reference Include="System.Data.Linq" />
     <Reference Include="System.ServiceModel" />
+    <Reference Include="System.Transactions" />
+    <Reference Include="System.Web" />
     <Reference Include="System.Xml.Linq" />
     <Reference Include="System.Data.DataSetExtensions" />
@@ -53,9 +57,13 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="Convert.cs" />
+    <Compile Include="AuthorizationManager.cs" />
     <Compile Include="HeuristicLabServicesHivePlugin.cs" />
+    <Compile Include="Hive.cs" />
     <Compile Include="HiveRoles.cs" />
     <Compile Include="HiveService.cs" />
+    <Compile Include="Interfaces\IAuthorizationManager.cs" />
+    <Compile Include="LifecycleManager.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="ServiceLocator.cs" />
   </ItemGroup>
   <ItemGroup>
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Server/3.3/Hive.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Server/3.3/Hive.cs	(revision 4598)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Server/3.3/Hive.cs	(revision 4598)
@@ -0,0 +1,81 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Transactions;
+using HeuristicLab.Services.Hive.Common;
+using HeuristicLab.Services.Hive.Common.DataTransfer;
+
+namespace HeuristicLab.Services.Hive {
+  public class Hive {
+    private static object locker = new object();
+    private Dictionary<Guid, DateTime> heartbeats = new Dictionary<Guid, DateTime>();
+
+    /// <summary>
+    /// Contains a list job JobIds which have been sent to a slave, but the slave has not yet sent 
+    /// a jobProgress of the job with a heartbeat, because he has not finished downloading/deserializing it.
+    /// The number value indicates a TimeToLive count that is decremented with each server-heartbeat.
+    /// When the number reaches zero, the jobs is assumed to be lost and is set Offline again.
+    /// </summary>
+    private Dictionary<Guid, int> newAssignedJobs = new Dictionary<Guid, int>();
+
+    private LifecycleManager lifecycleManager;
+
+    private DataAccess.IHiveDao dao { 
+      get { return ServiceLocator.Instance.HiveDao; } 
+    }
+    private DataAccess.IContextFactory<DataAccess.HiveDataContext> contextFactory { 
+      get { return ServiceLocator.Instance.ContextFactory; } 
+    }
+    private IAuthorizationManager auth {
+      get { return ServiceLocator.Instance.AuthorizationManager; }
+    }
+
+    public Hive() {
+      this.lifecycleManager = new LifecycleManager();
+      lifecycleManager.ServerHeartbeat += new EventHandler(lifecycleManager_ServerHeartbeat);
+    }
+
+    /// <summary>
+    /// Check if online slaves send their hearbeats
+    /// if not -> set them offline and check if they where calculating a job
+    /// </summary>
+    void lifecycleManager_ServerHeartbeat(object sender, EventArgs e) {
+      lock (locker) {
+        Guid[] slaveIds = dao.GetSlaves(x => true).Select(s => s.Id).ToArray();
+
+        foreach (Guid slaveId in slaveIds) {
+          if (!heartbeats.ContainsKey(slaveId)) {
+            // add a heartbeat NOW and give the slave time to say something for some time (HEARTBEAT_MAX_DIF)
+            // otherwise alls the slaves jobs would be aborted, which is not desirable if the server has just been restarted
+            heartbeats.Add(slaveId, DateTime.Now);
+          } else {
+            CheckTimeouts(slaveId);
+          }
+        }
+      }
+    }
+
+    private void CheckTimeouts(Guid slaveId) {
+      using (TransactionScope scope = new TransactionScope(TransactionScopeOption.Required, new TransactionOptions { IsolationLevel = ApplicationConstants.ISOLATION_LEVEL_SCOPE })) {
+        TimeSpan timeSinceLastHeartbeat = DateTime.Now - heartbeats[slaveId];
+        if (timeSinceLastHeartbeat.TotalSeconds > ApplicationConstants.HEARTBEAT_TIMEOUT) {
+          // slave timed out
+          var jobs = dao.GetJobs(x => x.Slave.ResourceId == slaveId);
+          foreach (var j in jobs) {
+            j.State = JobState.Waiting;
+            dao.UpdateJob(j);
+          }
+          var slave = dao.GetSlave(slaveId);
+          if (slave.State != SlaveState.Offline) {
+            slave.State = SlaveState.Offline;
+            dao.UpdateSlave(slave);
+          }
+          heartbeats.Remove(slaveId);
+        }
+        scope.Complete();
+      }
+    }
+
+  }
+}
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Server/3.3/HiveRoles.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Server/3.3/HiveRoles.cs	(revision 4595)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Server/3.3/HiveRoles.cs	(revision 4598)
@@ -21,5 +21,5 @@
 
 
-namespace HeuristicLab.Hive.Contracts {
+namespace HeuristicLab.Services.Hive {
   public static class HiveRoles {
     public const string Administrator = "Hive.Administrator";
